package de.itstall;

import de.itstall.model.Kontakt;
import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.stage.Stage;

import java.io.IOException;
import java.util.ArrayList;
import java.util.TreeMap;

/**
 * JavaFX App
 */
public class App extends Application {

    private static Scene scene;
    public static TreeMap<String, Kontakt> eintraege = new TreeMap<>();

    @Override
    public void start(Stage stage) throws IOException {
        scene = new Scene(loadFXML("Telefonbuch"));
        stage.setScene(scene);
        stage.show();
    }

    static void setRoot(String fxml) throws IOException {
        scene.setRoot(loadFXML(fxml));
    }

    private static Parent loadFXML(String fxml) throws IOException {
        FXMLLoader fxmlLoader = new FXMLLoader(App.class.getResource(fxml + ".fxml"));
        return fxmlLoader.load();
    }

    public static void main(String[] args) {
        launch();
    }

}